package hs.sort.example;

import anywheresoftware.b4a.B4AMenuItem;
import android.app.Activity;
import android.os.Bundle;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BALayout;
import anywheresoftware.b4a.B4AActivity;
import anywheresoftware.b4a.ObjectWrapper;
import anywheresoftware.b4a.objects.ActivityWrapper;
import java.lang.reflect.InvocationTargetException;
import anywheresoftware.b4a.B4AUncaughtException;
import anywheresoftware.b4a.debug.*;
import java.lang.ref.WeakReference;

public class main extends Activity implements B4AActivity{
	public static main mostCurrent;
	static boolean afterFirstLayout;
	static boolean isFirst = true;
    private static boolean processGlobalsRun = false;
	BALayout layout;
	public static BA processBA;
	BA activityBA;
    ActivityWrapper _activity;
    java.util.ArrayList<B4AMenuItem> menuItems;
	private static final boolean fullScreen = false;
	private static final boolean includeTitle = true;
    public static WeakReference<Activity> previousOne;

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		if (isFirst) {
			processBA = new BA(this.getApplicationContext(), null, null, "hs.sort.example", "hs.sort.example.main");
			processBA.loadHtSubs(this.getClass());
	        float deviceScale = getApplicationContext().getResources().getDisplayMetrics().density;
	        BALayout.setDeviceScale(deviceScale);
		}
		else if (previousOne != null) {
			Activity p = previousOne.get();
			if (p != null && p != this) {
                anywheresoftware.b4a.keywords.Common.Log("Killing previous instance (main).");
				p.finish();
			}
		}
		if (!includeTitle) {
        	this.getWindow().requestFeature(android.view.Window.FEATURE_NO_TITLE);
        }
        if (fullScreen) {
        	getWindow().setFlags(android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN,   
        			android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN);
        }
		mostCurrent = this;
        processBA.sharedProcessBA.activityBA = null;
		layout = new BALayout(this);
		setContentView(layout);
		afterFirstLayout = false;
		BA.handler.postDelayed(new WaitForLayout(), 5);

	}
	private static class WaitForLayout implements Runnable {
		public void run() {
			if (afterFirstLayout)
				return;
			if (mostCurrent == null)
				return;
			if (mostCurrent.layout.getWidth() == 0) {
				BA.handler.postDelayed(this, 5);
				return;
			}
			mostCurrent.layout.getLayoutParams().height = mostCurrent.layout.getHeight();
			mostCurrent.layout.getLayoutParams().width = mostCurrent.layout.getWidth();
			afterFirstLayout = true;
			mostCurrent.afterFirstLayout();
		}
	}
	private void afterFirstLayout() {
        if (this != mostCurrent)
			return;
		activityBA = new BA(this, layout, processBA, "hs.sort.example", "hs.sort.example.main");
        processBA.sharedProcessBA.activityBA = new java.lang.ref.WeakReference<BA>(activityBA);
        anywheresoftware.b4a.objects.ViewWrapper.lastId = 0;
        _activity = new ActivityWrapper(activityBA, "activity");
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        initializeProcessGlobals();		
        initializeGlobals();
        
        anywheresoftware.b4a.keywords.Common.Log("** Activity (main) Create, isFirst = " + isFirst + " **");
        processBA.raiseEvent2(null, true, "activity_create", false, isFirst);
		isFirst = false;
		if (this != mostCurrent)
			return;
        processBA.setActivityPaused(false);
        anywheresoftware.b4a.keywords.Common.Log("** Activity (main) Resume **");
        processBA.raiseEvent(null, "activity_resume");
        if (android.os.Build.VERSION.SDK_INT >= 11) {
			try {
				android.app.Activity.class.getMethod("invalidateOptionsMenu").invoke(this,(Object[]) null);
			} catch (Exception e) {
				e.printStackTrace();
			}
		}

	}
	public void addMenuItem(B4AMenuItem item) {
		if (menuItems == null)
			menuItems = new java.util.ArrayList<B4AMenuItem>();
		menuItems.add(item);
	}
	@Override
	public boolean onCreateOptionsMenu(android.view.Menu menu) {
		super.onCreateOptionsMenu(menu);
		if (menuItems == null)
			return false;
		for (B4AMenuItem bmi : menuItems) {
			android.view.MenuItem mi = menu.add(bmi.title);
			if (bmi.drawable != null)
				mi.setIcon(bmi.drawable);
            if (android.os.Build.VERSION.SDK_INT >= 11) {
				try {
                    if (bmi.addToBar) {
				        android.view.MenuItem.class.getMethod("setShowAsAction", int.class).invoke(mi, 1);
                    }
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
			mi.setOnMenuItemClickListener(new B4AMenuItemsClickListener(bmi.eventName.toLowerCase(BA.cul)));
		}
		return true;
	}
	private class B4AMenuItemsClickListener implements android.view.MenuItem.OnMenuItemClickListener {
		private final String eventName;
		public B4AMenuItemsClickListener(String eventName) {
			this.eventName = eventName;
		}
		public boolean onMenuItemClick(android.view.MenuItem item) {
			processBA.raiseEvent(item.getTitle(), eventName + "_click");
			return true;
		}
	}
    public static Class<?> getObject() {
		return main.class;
	}
    private Boolean onKeySubExist = null;
    private Boolean onKeyUpSubExist = null;
	@Override
	public boolean onKeyDown(int keyCode, android.view.KeyEvent event) {
		if (onKeySubExist == null)
			onKeySubExist = processBA.subExists("activity_keypress");
		if (onKeySubExist) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keypress", false, keyCode);
			if (res == null || res == true)
				return true;
            else if (keyCode == anywheresoftware.b4a.keywords.constants.KeyCodes.KEYCODE_BACK) {
				finish();
				return true;
			}
		}
		return super.onKeyDown(keyCode, event);
	}
    @Override
	public boolean onKeyUp(int keyCode, android.view.KeyEvent event) {
		if (onKeyUpSubExist == null)
			onKeyUpSubExist = processBA.subExists("activity_keyup");
		if (onKeyUpSubExist) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keyup", false, keyCode);
			if (res == null || res == true)
				return true;
		}
		return super.onKeyUp(keyCode, event);
	}
	@Override
	public void onNewIntent(android.content.Intent intent) {
		this.setIntent(intent);
	}
    @Override 
	public void onPause() {
		super.onPause();
        if (_activity == null) //workaround for emulator bug (Issue 2423)
            return;
		anywheresoftware.b4a.Msgbox.dismiss(true);
        anywheresoftware.b4a.keywords.Common.Log("** Activity (main) Pause, UserClosed = " + activityBA.activity.isFinishing() + " **");
        processBA.raiseEvent2(_activity, true, "activity_pause", false, activityBA.activity.isFinishing());		
        processBA.setActivityPaused(true);
        mostCurrent = null;
        if (!activityBA.activity.isFinishing())
			previousOne = new WeakReference<Activity>(this);
        anywheresoftware.b4a.Msgbox.isDismissing = false;
	}

	@Override
	public void onDestroy() {
        super.onDestroy();
		previousOne = null;
	}
    @Override 
	public void onResume() {
		super.onResume();
        mostCurrent = this;
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (activityBA != null) { //will be null during activity create (which waits for AfterLayout).
        	ResumeMessage rm = new ResumeMessage(mostCurrent);
        	BA.handler.post(rm);
        }
	}
    private static class ResumeMessage implements Runnable {
    	private final WeakReference<Activity> activity;
    	public ResumeMessage(Activity activity) {
    		this.activity = new WeakReference<Activity>(activity);
    	}
		public void run() {
			if (mostCurrent == null || mostCurrent != activity.get())
				return;
			processBA.setActivityPaused(false);
            anywheresoftware.b4a.keywords.Common.Log("** Activity (main) Resume **");
		    processBA.raiseEvent(mostCurrent._activity, "activity_resume", (Object[])null);
		}
    }
	@Override
	protected void onActivityResult(int requestCode, int resultCode,
	      android.content.Intent data) {
		processBA.onActivityResult(requestCode, resultCode, data);
	}
	private static void initializeGlobals() {
		processBA.raiseEvent2(null, true, "globals", false, (Object[])null);
	}

public anywheresoftware.b4a.keywords.Common __c = null;
public anywheresoftware.b4a.objects.collections.List _mylist = null;
public anywheresoftware.b4a.objects.ListViewWrapper _listview1 = null;
public anywheresoftware.b4a.objects.ButtonWrapper _button1 = null;
public anywheresoftware.b4a.objects.ButtonWrapper _button2 = null;
public anywheresoftware.b4a.objects.LabelWrapper _label1 = null;
public hs.sort.example.sort_list _sort_list = null;
public static String  _activity_create(boolean _firsttime) throws Exception{
int _i = 0;
 //BA.debugLineNum = 31;BA.debugLine="Sub Activity_Create(FirstTime As Boolean)";
 //BA.debugLineNum = 33;BA.debugLine="Activity.LoadLayout(\"Layout1\")";
mostCurrent._activity.LoadLayout("Layout1",mostCurrent.activityBA);
 //BA.debugLineNum = 34;BA.debugLine="ListView1.Width=Activity.Width";
mostCurrent._listview1.setWidth(mostCurrent._activity.getWidth());
 //BA.debugLineNum = 35;BA.debugLine="Label1.TextSize=20";
mostCurrent._label1.setTextSize((float)(20));
 //BA.debugLineNum = 37;BA.debugLine="mylist.Initialize";
mostCurrent._mylist.Initialize();
 //BA.debugLineNum = 39;BA.debugLine="create_list";
_create_list();
 //BA.debugLineNum = 41;BA.debugLine="ListView1.Clear";
mostCurrent._listview1.Clear();
 //BA.debugLineNum = 42;BA.debugLine="For i=0 To mylist.Size-1";
{
final double step16 = 1;
final double limit16 = (int)(mostCurrent._mylist.getSize()-1);
for (_i = (int)(0); (step16 > 0 && _i <= limit16) || (step16 < 0 && _i >= limit16); _i += step16) {
 //BA.debugLineNum = 43;BA.debugLine="ListView1.AddSingleLine(mylist.Get(i))";
mostCurrent._listview1.AddSingleLine(String.valueOf(mostCurrent._mylist.Get(_i)));
 }
};
 //BA.debugLineNum = 46;BA.debugLine="End Sub";
return "";
}
public static String  _activity_pause(boolean _userclosed) throws Exception{
 //BA.debugLineNum = 73;BA.debugLine="Sub Activity_Pause (UserClosed As Boolean)";
 //BA.debugLineNum = 75;BA.debugLine="End Sub";
return "";
}
public static String  _activity_resume() throws Exception{
 //BA.debugLineNum = 69;BA.debugLine="Sub Activity_Resume";
 //BA.debugLineNum = 71;BA.debugLine="End Sub";
return "";
}
public static String  _btn_clear_click() throws Exception{
int _i = 0;
 //BA.debugLineNum = 92;BA.debugLine="Sub btn_clear_Click";
 //BA.debugLineNum = 93;BA.debugLine="mylist.Clear";
mostCurrent._mylist.Clear();
 //BA.debugLineNum = 94;BA.debugLine="create_list";
_create_list();
 //BA.debugLineNum = 96;BA.debugLine="ListView1.Clear";
mostCurrent._listview1.Clear();
 //BA.debugLineNum = 97;BA.debugLine="For i=0 To mylist.Size-1";
{
final double step51 = 1;
final double limit51 = (int)(mostCurrent._mylist.getSize()-1);
for (_i = (int)(0); (step51 > 0 && _i <= limit51) || (step51 < 0 && _i >= limit51); _i += step51) {
 //BA.debugLineNum = 98;BA.debugLine="ListView1.AddSingleLine(mylist.Get(i))";
mostCurrent._listview1.AddSingleLine(String.valueOf(mostCurrent._mylist.Get(_i)));
 }
};
 //BA.debugLineNum = 100;BA.debugLine="End Sub";
return "";
}
public static String  _btn_sort_click() throws Exception{
int _position = 0;
int _i = 0;
 //BA.debugLineNum = 77;BA.debugLine="Sub btn_sort_Click";
 //BA.debugLineNum = 78;BA.debugLine="Dim position As Int ' position must be less than array size";
_position = 0;
 //BA.debugLineNum = 79;BA.debugLine="position=2 ' define positon of cryteria element , ignore if custom defined cryteria";
_position = (int)(2);
 //BA.debugLineNum = 80;BA.debugLine="Label1.Text=\"sort:\"&position";
mostCurrent._label1.setText((Object)("sort:"+BA.NumberToString(_position)));
 //BA.debugLineNum = 82;BA.debugLine="mylist=sort_list.sort(mylist,\",\",position)";
mostCurrent._mylist = mostCurrent._sort_list._sort(mostCurrent.activityBA,mostCurrent._mylist,",",_position);
 //BA.debugLineNum = 86;BA.debugLine="ListView1.Clear";
mostCurrent._listview1.Clear();
 //BA.debugLineNum = 87;BA.debugLine="For i=0 To mylist.Size-1";
{
final double step43 = 1;
final double limit43 = (int)(mostCurrent._mylist.getSize()-1);
for (_i = (int)(0); (step43 > 0 && _i <= limit43) || (step43 < 0 && _i >= limit43); _i += step43) {
 //BA.debugLineNum = 88;BA.debugLine="ListView1.AddSingleLine(mylist.Get(i))";
mostCurrent._listview1.AddSingleLine(String.valueOf(mostCurrent._mylist.Get(_i)));
 }
};
 //BA.debugLineNum = 91;BA.debugLine="End Sub";
return "";
}
public static String  _create_list() throws Exception{
int _token = 0;
int _i = 0;
anywheresoftware.b4a.keywords.StringBuilderWrapper _sb = null;
 //BA.debugLineNum = 47;BA.debugLine="Sub create_list";
 //BA.debugLineNum = 48;BA.debugLine="Dim token As Int";
_token = 0;
 //BA.debugLineNum = 52;BA.debugLine="For i=0 To 100";
{
final double step22 = 1;
final double limit22 = (int)(100);
for (_i = (int)(0); (step22 > 0 && _i <= limit22) || (step22 < 0 && _i >= limit22); _i += step22) {
 //BA.debugLineNum = 53;BA.debugLine="token=Rnd(0,1000)";
_token = anywheresoftware.b4a.keywords.Common.Rnd((int)(0),(int)(1000));
 //BA.debugLineNum = 55;BA.debugLine="Dim sb As StringBuilder";
_sb = new anywheresoftware.b4a.keywords.StringBuilderWrapper();
 //BA.debugLineNum = 56;BA.debugLine="sb.Initialize";
_sb.Initialize();
 //BA.debugLineNum = 58;BA.debugLine="sb.Append(Rnd(2,11)).Append(\",\")";
_sb.Append(BA.NumberToString(anywheresoftware.b4a.keywords.Common.Rnd((int)(2),(int)(11)))).Append(",");
 //BA.debugLineNum = 59;BA.debugLine="sb.Append(Rnd(20,60)).Append(\",\")";
_sb.Append(BA.NumberToString(anywheresoftware.b4a.keywords.Common.Rnd((int)(20),(int)(60)))).Append(",");
 //BA.debugLineNum = 60;BA.debugLine="sb.Append(token).Append(\",\")";
_sb.Append(BA.NumberToString(_token)).Append(",");
 //BA.debugLineNum = 61;BA.debugLine="sb.Append(\"item\"&token)";
_sb.Append("item"+BA.NumberToString(_token));
 //BA.debugLineNum = 64;BA.debugLine="mylist.Add(sb.ToString)";
mostCurrent._mylist.Add((Object)(_sb.ToString()));
 }
};
 //BA.debugLineNum = 68;BA.debugLine="End Sub";
return "";
}

public static void initializeProcessGlobals() {
    
    if (processGlobalsRun == false) {
	    processGlobalsRun = true;
		try {
		        main._process_globals();
sort_list._process_globals();
		
        } catch (Exception e) {
			throw new RuntimeException(e);
		}
    }
}

public static boolean isAnyActivityVisible() {
    boolean vis = false;
vis = vis | (main.mostCurrent != null);
return vis;}
public static String  _globals() throws Exception{
 //BA.debugLineNum = 21;BA.debugLine="Sub Globals";
 //BA.debugLineNum = 24;BA.debugLine="Dim mylist As List";
mostCurrent._mylist = new anywheresoftware.b4a.objects.collections.List();
 //BA.debugLineNum = 25;BA.debugLine="Dim ListView1 As ListView";
mostCurrent._listview1 = new anywheresoftware.b4a.objects.ListViewWrapper();
 //BA.debugLineNum = 26;BA.debugLine="Dim Button1 As Button";
mostCurrent._button1 = new anywheresoftware.b4a.objects.ButtonWrapper();
 //BA.debugLineNum = 27;BA.debugLine="Dim Button2 As Button";
mostCurrent._button2 = new anywheresoftware.b4a.objects.ButtonWrapper();
 //BA.debugLineNum = 28;BA.debugLine="Dim Label1 As Label";
mostCurrent._label1 = new anywheresoftware.b4a.objects.LabelWrapper();
 //BA.debugLineNum = 29;BA.debugLine="End Sub";
return "";
}
public static String  _process_globals() throws Exception{
 //BA.debugLineNum = 15;BA.debugLine="Sub Process_Globals";
 //BA.debugLineNum = 19;BA.debugLine="End Sub";
return "";
}
}
